Package org.apache.commons.collections4.bag

# Class TransformedBag<E>

java.lang.Object
org.apache.commons.collections4.collection.AbstractCollectionDecorator<E>
org.apache.commons.collections4.collection.TransformedCollection<E>
org.apache.commons.collections4.bag.TransformedBag<E>

Type Parameters:
  `E` - the type of elements in this bag

All Implemented Interfaces:
  `Serializable`, `Iterable<E>`, `Collection<E>`, `Bag<E>`

Direct Known Subclasses:
  `TransformedSortedBag`

public class TransformedBag<E> extends TransformedCollection<E> implements Bag<E>
Decorates another `Bag` to transform objects that are added.

The add methods are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

This class is Serializable from Commons Collections 3.1.

Since:
  3.0
See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class org.apache.commons.collections4.collection.TransformedCollection

  `transformer`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `TransformedBag(Bag<E> bag, Transformer<? super E,? extends E> transformer)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(E object, int nCopies)`
  Adds `nCopies` copies of the specified object to the Bag.
  `boolean`
  `equals(Object object)`
  `protected Bag<E>`
  `getBag()`
  Gets the decorated bag.
  `int`
  `getCount(Object object)`
  Returns the number of occurrences (cardinality) of the given object currently in the bag.
  `int`
  `hashCode()`
  `boolean`
  `remove(Object object, int nCopies)`
  Removes `nCopies` copies of the specified object from the Bag.
  `static <E> Bag<E>`
  `transformedBag(Bag<E> bag, Transformer<? super E,? extends E> transformer)`
  Factory method to create a transforming bag that will transform existing contents of the specified bag.
  `static <E> Bag<E>`
  `transformingBag(Bag<E> bag, Transformer<? super E,? extends E> transformer)`
  Factory method to create a transforming bag.
  `Set<E>`
  `uniqueSet()`
  Returns a `Set` of unique elements in the Bag.

  ### Methods inherited from class org.apache.commons.collections4.collection.TransformedCollection

  `add, addAll, transform, transform, transformedCollection, transformingCollection`

  ### Methods inherited from class org.apache.commons.collections4.collection.AbstractCollectionDecorator

  `clear, contains, containsAll, decorated, isEmpty, iterator, remove, removeAll, removeIf, retainAll, setCollection, size, toArray, toArray, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.Bag

  `add, containsAll, iterator, remove, removeAll, retainAll, size`

  ### Methods inherited from interface java.util.Collection

  `addAll, clear, contains, isEmpty, parallelStream, removeIf, spliterator, stream, toArray, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

- ## Constructor Details

  - ### TransformedBag

    protected TransformedBag(Bag<E> bag, Transformer<? super E,? extends E> transformer)
    Constructor that wraps (not copies).

    If there are any elements already in the bag being decorated, they are NOT transformed.

    Parameters:
      `bag` - the bag to decorate, must not be null
      `transformer` - the transformer to use for conversion, must not be null
    Throws:
      `NullPointerException` - if bag or transformer is null

- ## Method Details

  - ### transformedBag

    public static <E> Bag<E> transformedBag(Bag<E> bag, Transformer<? super E,? extends E> transformer)
    Factory method to create a transforming bag that will transform existing contents of the specified bag.

    If there are any elements already in the bag being decorated, they will be transformed by this method. Contrast this with `transformingBag(Bag, Transformer)`.

    Type Parameters:
      `E` - the type of the elements in the bag
    Parameters:
      `bag` - the bag to decorate, must not be null
      `transformer` - the transformer to use for conversion, must not be null
    Returns:
      a new transformed Bag
    Throws:
      `NullPointerException` - if bag or transformer is null
    Since:
      4.0

  - ### transformingBag

    public static <E> Bag<E> transformingBag(Bag<E> bag, Transformer<? super E,? extends E> transformer)
    Factory method to create a transforming bag.

    If there are any elements already in the bag being decorated, they are NOT transformed. Contrast this with `transformedBag(Bag, Transformer)`.

    Type Parameters:
      `E` - the type of the elements in the bag
    Parameters:
      `bag` - the bag to decorate, must not be null
      `transformer` - the transformer to use for conversion, must not be null
    Returns:
      a new transformed Bag
    Throws:
      `NullPointerException` - if bag or transformer is null
    Since:
      4.0

  - ### add

    public boolean add(E object, int nCopies)
    Description copied from interface: `Bag`
    Adds `nCopies` copies of the specified object to the Bag.

    If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

    Specified by:
      `add` in interface `Bag<E>`
    Parameters:
      `object` - the object to add
      `nCopies` - the number of copies to add
    Returns:
      `true` if the object was not already in the `uniqueSet`

  - ### equals

    public boolean equals(Object object)
    Specified by:
      `equals` in interface `Collection<E>`
    Overrides:
      `equals` in class `Object`

  - ### getBag

    protected Bag<E> getBag()
    Gets the decorated bag.
    Returns:
      the decorated bag

  - ### getCount

    public int getCount(Object object)
    Description copied from interface: `Bag`
    Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.
    Specified by:
      `getCount` in interface `Bag<E>`
    Parameters:
      `object` - the object to search for
    Returns:
      the number of occurrences of the object, zero if not found

  - ### hashCode

    public int hashCode()
    Specified by:
      `hashCode` in interface `Collection<E>`
    Overrides:
      `hashCode` in class `Object`

  - ### remove

    public boolean remove(Object object, int nCopies)
    Description copied from interface: `Bag`
    Removes `nCopies` copies of the specified object from the Bag.

    If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

    Specified by:
      `remove` in interface `Bag<E>`
    Parameters:
      `object` - the object to remove
      `nCopies` - the number of copies to remove
    Returns:
      `true` if this call changed the collection

  - ### uniqueSet

    public Set<E> uniqueSet()
    Description copied from interface: `Bag`
    Returns a `Set` of unique elements in the Bag.

    Uniqueness constraints are the same as those in `Set`.

    Specified by:
      `uniqueSet` in interface `Bag<E>`
    Returns:
      the Set of unique Bag elements